# generated from catkin/cmake/template/pkgConfig.cmake.in

# append elements to a list and remove existing duplicates from the list
# copied from catkin/cmake/list_append_deduplicate.cmake to keep pkgConfig
# self contained
macro(_list_append_deduplicate listname)
  if(NOT "${ARGN}" STREQUAL "")
    if(${listname})
      list(REMOVE_ITEM ${listname} ${ARGN})
    endif()
    list(APPEND ${listname} ${ARGN})
  endif()
endmacro()

# append elements to a list if they are not already in the list
# copied from catkin/cmake/list_append_unique.cmake to keep pkgConfig
# self contained
macro(_list_append_unique listname)
  foreach(_item ${ARGN})
    list(FIND ${listname} ${_item} _index)
    if(_index EQUAL -1)
      list(APPEND ${listname} ${_item})
    endif()
  endforeach()
endmacro()

# pack a list of libraries with optional build configuration keywords
# copied from catkin/cmake/catkin_libraries.cmake to keep pkgConfig
# self contained
macro(_pack_libraries_with_build_configuration VAR)
  set(${VAR} "")
  set(_argn ${ARGN})
  list(LENGTH _argn _count)
  set(_index 0)
  while(${_index} LESS ${_count})
    list(GET _argn ${_index} lib)
    if("${lib}" MATCHES "^(debug|optimized|general)$")
      math(EXPR _index "${_index} + 1")
      if(${_index} EQUAL ${_count})
        message(FATAL_ERROR "_pack_libraries_with_build_configuration() the list of libraries '${ARGN}' ends with '${lib}' which is a build configuration keyword and must be followed by a library")
      endif()
      list(GET _argn ${_index} library)
      list(APPEND ${VAR} "${lib}${CATKIN_BUILD_CONFIGURATION_KEYWORD_SEPARATOR}${library}")
    else()
      list(APPEND ${VAR} "${lib}")
    endif()
    math(EXPR _index "${_index} + 1")
  endwhile()
endmacro()

# unpack a list of libraries with optional build configuration keyword prefixes
# copied from catkin/cmake/catkin_libraries.cmake to keep pkgConfig
# self contained
macro(_unpack_libraries_with_build_configuration VAR)
  set(${VAR} "")
  foreach(lib ${ARGN})
    string(REGEX REPLACE "^(debug|optimized|general)${CATKIN_BUILD_CONFIGURATION_KEYWORD_SEPARATOR}(.+)$" "\\1;\\2" lib "${lib}")
    list(APPEND ${VAR} "${lib}")
  endforeach()
endmacro()


if(webrtc_ros_CONFIG_INCLUDED)
  return()
endif()
set(webrtc_ros_CONFIG_INCLUDED TRUE)

# set variables for source/devel/install prefixes
if("FALSE" STREQUAL "TRUE")
  set(webrtc_ros_SOURCE_PREFIX /tmp/binarydeb/ros-melodic-webrtc-ros-59.0.3)
  set(webrtc_ros_DEVEL_PREFIX /tmp/binarydeb/ros-melodic-webrtc-ros-59.0.3/obj-x86_64-linux-gnu/devel)
  set(webrtc_ros_INSTALL_PREFIX "")
  set(webrtc_ros_PREFIX ${webrtc_ros_DEVEL_PREFIX})
else()
  set(webrtc_ros_SOURCE_PREFIX "")
  set(webrtc_ros_DEVEL_PREFIX "")
  set(webrtc_ros_INSTALL_PREFIX /opt/ros/melodic)
  set(webrtc_ros_PREFIX ${webrtc_ros_INSTALL_PREFIX})
endif()

# warn when using a deprecated package
if(NOT "" STREQUAL "")
  set(_msg "WARNING: package 'webrtc_ros' is deprecated")
  # append custom deprecation text if available
  if(NOT "" STREQUAL "TRUE")
    set(_msg "${_msg} ()")
  endif()
  message("${_msg}")
endif()

# flag project as catkin-based to distinguish if a find_package()-ed project is a catkin project
set(webrtc_ros_FOUND_CATKIN_PROJECT TRUE)

if(NOT "/opt/ros/melodic/include;/opt/ros/melodic/include/webrtc/3rdparty " STREQUAL " ")
  set(webrtc_ros_INCLUDE_DIRS "")
  set(_include_dirs "/opt/ros/melodic/include;/opt/ros/melodic/include/webrtc/3rdparty")
  if(NOT "https://github.com/RobotWebTools/webrtc_ros/issues " STREQUAL " ")
    set(_report "Check the issue tracker 'https://github.com/RobotWebTools/webrtc_ros/issues' and consider creating a ticket if the problem has not been reported yet.")
  elseif(NOT "http://wiki.ros.org/webrtc_ros " STREQUAL " ")
    set(_report "Check the website 'http://wiki.ros.org/webrtc_ros' for information and consider reporting the problem.")
  else()
    set(_report "Report the problem to the maintainer 'Timo Röhling <timo.roehling@fkie.fraunhofer.de>' and request to fix the problem.")
  endif()
  foreach(idir ${_include_dirs})
    if(IS_ABSOLUTE ${idir} AND IS_DIRECTORY ${idir})
      set(include ${idir})
    elseif("${idir} " STREQUAL "include ")
      get_filename_component(include "${webrtc_ros_DIR}/../../../include" ABSOLUTE)
      if(NOT IS_DIRECTORY ${include})
        message(FATAL_ERROR "Project 'webrtc_ros' specifies '${idir}' as an include dir, which is not found.  It does not exist in '${include}'.  ${_report}")
      endif()
    else()
      message(FATAL_ERROR "Project 'webrtc_ros' specifies '${idir}' as an include dir, which is not found.  It does neither exist as an absolute directory nor in '/opt/ros/melodic/${idir}'.  ${_report}")
    endif()
    _list_append_unique(webrtc_ros_INCLUDE_DIRS ${include})
  endforeach()
endif()

set(libraries "/opt/ros/melodic/lib/libwebrtc.a;/opt/ros/melodic/lib/libwebrtc_common.a;/opt/ros/melodic/lib/libwebrtc_rtc_pc.a;/opt/ros/melodic/lib/libwebrtc_jingle_peerconnection.a;/opt/ros/melodic/lib/libwebrtc_audio.a;/opt/ros/melodic/lib/libwebrtc_audio_frame_operations.a;/opt/ros/melodic/lib/libwebrtc_video.a;/opt/ros/melodic/lib/libwebrtc_rtc_media.a;/opt/ros/melodic/lib/libwebrtc_rtc_media_base.a;/opt/ros/melodic/lib/libwebrtc_common_video.a;/opt/ros/melodic/lib/libwebrtc_call.a;/opt/ros/melodic/lib/libwebrtc_jingle_peerconnection_api.a;/opt/ros/melodic/lib/libwebrtc_builtin_audio_decoder_factory.a;/opt/ros/melodic/lib/libwebrtc_rtc_numerics.a;/opt/ros/melodic/lib/libwebrtc_rtc_base.a;/opt/ros/melodic/lib/libwebrtc_rtc_base_approved.a;/opt/ros/melodic/lib/libwebrtc_rtc_task_queue.a;/opt/ros/melodic/lib/libwebrtc_cpu_features_linux.a;/opt/ros/melodic/lib/libwebrtc_metrics_default.a;/opt/ros/melodic/lib/libwebrtc_system_wrappers.a;/opt/ros/melodic/lib/libwebrtc_field_trial_default.a;/opt/ros/melodic/lib/libwebrtc_common_audio.a;/opt/ros/melodic/lib/libwebrtc_common_audio_sse2.a;/opt/ros/melodic/lib/libwebrtc_rtc_p2p.a;/opt/ros/melodic/lib/libwebrtc_stunprober.a;/opt/ros/melodic/lib/libwebrtc_rtc_stats.a;/opt/ros/melodic/lib/libwebrtc_ortc.a;/opt/ros/melodic/lib/libwebrtc_remote_bitrate_estimator.a;/opt/ros/melodic/lib/libwebrtc_desktop_capture.a;/opt/ros/melodic/lib/libwebrtc_desktop_capture_differ_sse2.a;/opt/ros/melodic/lib/libwebrtc_primitives.a;/opt/ros/melodic/lib/libwebrtc_media_file.a;/opt/ros/melodic/lib/libwebrtc_audio_frame_manipulator.a;/opt/ros/melodic/lib/libwebrtc_audio_mixer_impl.a;/opt/ros/melodic/lib/libwebrtc_utility.a;/opt/ros/melodic/lib/libwebrtc_pacing.a;/opt/ros/melodic/lib/libwebrtc_audio_processing_sse2.a;/opt/ros/melodic/lib/libwebrtc_audio_processing.a;/opt/ros/melodic/lib/libwebrtc_rtp_rtcp.a;/opt/ros/melodic/lib/libwebrtc_video_coding_utility.a;/opt/ros/melodic/lib/libwebrtc_h264.a;/opt/ros/melodic/lib/libwebrtc_i420.a;/opt/ros/melodic/lib/libwebrtc_vp8.a;/opt/ros/melodic/lib/libwebrtc_video_coding.a;/opt/ros/melodic/lib/libwebrtc_vp9.a;/opt/ros/melodic/lib/libwebrtc_bitrate_controller.a;/opt/ros/melodic/lib/libwebrtc_video_processing.a;/opt/ros/melodic/lib/libwebrtc_video_processing_sse2.a;/opt/ros/melodic/lib/libwebrtc_audio_conference_mixer.a;/opt/ros/melodic/lib/libwebrtc_video_capture_internal_impl.a;/opt/ros/melodic/lib/libwebrtc_video_capture_module.a;/opt/ros/melodic/lib/libwebrtc_legacy_encoded_audio_frame.a;/opt/ros/melodic/lib/libwebrtc_opus.a;/opt/ros/melodic/lib/libwebrtc_g722.a;/opt/ros/melodic/lib/libwebrtc_isac_common.a;/opt/ros/melodic/lib/libwebrtc_builtin_audio_encoder_factory.a;/opt/ros/melodic/lib/libwebrtc_ilbc.a;/opt/ros/melodic/lib/libwebrtc_isac_fix.a;/opt/ros/melodic/lib/libwebrtc_cng.a;/opt/ros/melodic/lib/libwebrtc_rent_a_codec.a;/opt/ros/melodic/lib/libwebrtc_neteq.a;/opt/ros/melodic/lib/libwebrtc_pcm16b.a;/opt/ros/melodic/lib/libwebrtc_isac_c.a;/opt/ros/melodic/lib/libwebrtc_red.a;/opt/ros/melodic/lib/libwebrtc_audio_coding.a;/opt/ros/melodic/lib/libwebrtc_audio_format_conversion.a;/opt/ros/melodic/lib/libwebrtc_builtin_audio_decoder_factory_internal.a;/opt/ros/melodic/lib/libwebrtc_audio_network_adaptor.a;/opt/ros/melodic/lib/libwebrtc_g711.a;/opt/ros/melodic/lib/libwebrtc_audio_encoder_interface.a;/opt/ros/melodic/lib/libwebrtc_isac.a;/opt/ros/melodic/lib/libwebrtc_audio_device.a;/opt/ros/melodic/lib/libwebrtc_congestion_controller.a;/opt/ros/melodic/lib/libwebrtc_file_player.a;/opt/ros/melodic/lib/libwebrtc_audio_level.a;/opt/ros/melodic/lib/libwebrtc_file_recorder.a;/opt/ros/melodic/lib/libwebrtc_audio_coder.a;/opt/ros/melodic/lib/libwebrtc_voice_engine.a;/opt/ros/melodic/lib/libwebrtc_rtc_event_log_impl.a;/opt/ros/melodic/lib/libwebrtc_ext_opus.a;/opt/ros/melodic/lib/libwebrtc_ext_srtp.a;/opt/ros/melodic/lib/libwebrtc_ext_vpx.a;/opt/ros/melodic/lib/libwebrtc_ext_vpx_yasm.a;/opt/ros/melodic/lib/libwebrtc_ext_dl.a;/opt/ros/melodic/lib/libwebrtc_ext_yasm_utils.a;/opt/ros/melodic/lib/libwebrtc_ext_boringssl.a;/opt/ros/melodic/lib/libwebrtc_ext_yuv_internal.a;/opt/ros/melodic/lib/libwebrtc_ext_usrsctp.a;/opt/ros/melodic/lib/libwebrtc_ext_jpeg.a;/opt/ros/melodic/lib/libwebrtc_ext_simd_asm.a;/opt/ros/melodic/lib/libwebrtc_ext_simd.a")
foreach(library ${libraries})
  # keep build configuration keywords, target names and absolute libraries as-is
  if("${library}" MATCHES "^(debug|optimized|general)$")
    list(APPEND webrtc_ros_LIBRARIES ${library})
  elseif(${library} MATCHES "^-l")
    list(APPEND webrtc_ros_LIBRARIES ${library})
  elseif(TARGET ${library})
    list(APPEND webrtc_ros_LIBRARIES ${library})
  elseif(IS_ABSOLUTE ${library})
    list(APPEND webrtc_ros_LIBRARIES ${library})
  else()
    set(lib_path "")
    set(lib "${library}-NOTFOUND")
    # since the path where the library is found is returned we have to iterate over the paths manually
    foreach(path /opt/ros/melodic/lib;/opt/ros/melodic/lib)
      find_library(lib ${library}
        PATHS ${path}
        NO_DEFAULT_PATH NO_CMAKE_FIND_ROOT_PATH)
      if(lib)
        set(lib_path ${path})
        break()
      endif()
    endforeach()
    if(lib)
      _list_append_unique(webrtc_ros_LIBRARY_DIRS ${lib_path})
      list(APPEND webrtc_ros_LIBRARIES ${lib})
    else()
      # as a fall back for non-catkin libraries try to search globally
      find_library(lib ${library})
      if(NOT lib)
        message(FATAL_ERROR "Project '${PROJECT_NAME}' tried to find library '${library}'.  The library is neither a target nor built/installed properly.  Did you compile project 'webrtc_ros'?  Did you find_package() it before the subdirectory containing its code is included?")
      endif()
      list(APPEND webrtc_ros_LIBRARIES ${lib})
    endif()
  endif()
endforeach()

set(webrtc_ros_EXPORTED_TARGETS "")
# create dummy targets for exported code generation targets to make life of users easier
foreach(t ${webrtc_ros_EXPORTED_TARGETS})
  if(NOT TARGET ${t})
    add_custom_target(${t})
  endif()
endforeach()

set(depends "async_web_server_cpp;cv_bridge;image_transport;nodelet;roscpp")
foreach(depend ${depends})
  string(REPLACE " " ";" depend_list ${depend})
  # the package name of the dependency must be kept in a unique variable so that it is not overwritten in recursive calls
  list(GET depend_list 0 webrtc_ros_dep)
  list(LENGTH depend_list count)
  if(${count} EQUAL 1)
    # simple dependencies must only be find_package()-ed once
    if(NOT ${webrtc_ros_dep}_FOUND)
      find_package(${webrtc_ros_dep} REQUIRED NO_MODULE)
    endif()
  else()
    # dependencies with components must be find_package()-ed again
    list(REMOVE_AT depend_list 0)
    find_package(${webrtc_ros_dep} REQUIRED NO_MODULE ${depend_list})
  endif()
  _list_append_unique(webrtc_ros_INCLUDE_DIRS ${${webrtc_ros_dep}_INCLUDE_DIRS})

  # merge build configuration keywords with library names to correctly deduplicate
  _pack_libraries_with_build_configuration(webrtc_ros_LIBRARIES ${webrtc_ros_LIBRARIES})
  _pack_libraries_with_build_configuration(_libraries ${${webrtc_ros_dep}_LIBRARIES})
  _list_append_deduplicate(webrtc_ros_LIBRARIES ${_libraries})
  # undo build configuration keyword merging after deduplication
  _unpack_libraries_with_build_configuration(webrtc_ros_LIBRARIES ${webrtc_ros_LIBRARIES})

  _list_append_unique(webrtc_ros_LIBRARY_DIRS ${${webrtc_ros_dep}_LIBRARY_DIRS})
  list(APPEND webrtc_ros_EXPORTED_TARGETS ${${webrtc_ros_dep}_EXPORTED_TARGETS})
endforeach()

set(pkg_cfg_extras "")
foreach(extra ${pkg_cfg_extras})
  if(NOT IS_ABSOLUTE ${extra})
    set(extra ${webrtc_ros_DIR}/${extra})
  endif()
  include(${extra})
endforeach()
